//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private DTTWNews3T[] cacheDTTWNews3T = null;

        private static DTTWNews3T checkDTTWNews3T = new DTTWNews3T();

        /// <summary>
        /// Displays upcoming economic news.  Downloaded from www.DayTradeToWin.com.
        /// </summary>
        /// <returns></returns>
        public DTTWNews3T DTTWNews3T()
        {
            return DTTWNews3T(Input);
        }

        /// <summary>
        /// Displays upcoming economic news.  Downloaded from www.DayTradeToWin.com.
        /// </summary>
        /// <returns></returns>
        public DTTWNews3T DTTWNews3T(Data.IDataSeries input)
        {
            if (cacheDTTWNews3T != null)
                for (int idx = 0; idx < cacheDTTWNews3T.Length; idx++)
                    if (cacheDTTWNews3T[idx].EqualsInput(input))
                        return cacheDTTWNews3T[idx];

            lock (checkDTTWNews3T)
            {
                if (cacheDTTWNews3T != null)
                    for (int idx = 0; idx < cacheDTTWNews3T.Length; idx++)
                        if (cacheDTTWNews3T[idx].EqualsInput(input))
                            return cacheDTTWNews3T[idx];

                DTTWNews3T indicator = new DTTWNews3T();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                DTTWNews3T[] tmp = new DTTWNews3T[cacheDTTWNews3T == null ? 1 : cacheDTTWNews3T.Length + 1];
                if (cacheDTTWNews3T != null)
                    cacheDTTWNews3T.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheDTTWNews3T = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Displays upcoming economic news.  Downloaded from www.DayTradeToWin.com.
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.DTTWNews3T DTTWNews3T()
        {
            return _indicator.DTTWNews3T(Input);
        }

        /// <summary>
        /// Displays upcoming economic news.  Downloaded from www.DayTradeToWin.com.
        /// </summary>
        /// <returns></returns>
        public Indicator.DTTWNews3T DTTWNews3T(Data.IDataSeries input)
        {
            return _indicator.DTTWNews3T(input);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Displays upcoming economic news.  Downloaded from www.DayTradeToWin.com.
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.DTTWNews3T DTTWNews3T()
        {
            return _indicator.DTTWNews3T(Input);
        }

        /// <summary>
        /// Displays upcoming economic news.  Downloaded from www.DayTradeToWin.com.
        /// </summary>
        /// <returns></returns>
        public Indicator.DTTWNews3T DTTWNews3T(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.DTTWNews3T(input);
        }
    }
}
#endregion
